#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Molecular Geometry",0
Line1:
	.db " Linear",0
Line2:
	.db " Trigonal Planar",0
Line3:
	.db " Bent od V-Shaped",0
Line4:
	.db " Trigonal Pyramid",0
Line5:
	.db " Tetrahedral",0
Keys:
	.db "      ",6,"  ",7," move    ENTER   select    EXIT   quits",0
Title:
	.db "Molecular Geometry-By Adam Martin",0
ProgStart:
	call _clrLCD
	call _runindicoff
	ld hl,$0100
	ld (_penCol),hl
	call TopBlack
	ld hl,Title
	call WriteReset
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,Line1
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,Line2
	call _vputs
	ld hl,$1C00
	ld (_penCol),hl
	ld hl,Line3
	call _vputs
	ld hl,$2300
	ld (_penCol),hl
	ld hl,Line4
	call _vputs
	ld hl,$2A00
	ld (_penCol),hl
	ld hl,Line5
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,Keys
	call _vputs
	call BottomBlack
	ld c,5
DoMenuDTL:
	ld a,d
	add a,7
	ld d,a	
	djnz DoMenuDTL	
	ld b,1	
	call DoMenuInvBar	
DoMenuL:
	push bc	
	call _getky	
	pop bc	
	cp K_UP	
	jr z,DoMenuUp	
	cp K_EXIT
	jp z,Exit
	cp K_DOWN	
	jr z,DoMenuDown
	cp K_ENTER
	jp z,WhichType
	jr DoMenuL	
DoMenuUp:
	call DoMenuInvBar	
	dec b
	jr nz,DoMenuBar
	ld b,5
	jr DoMenuBar
DoMenuDown:
	call DoMenuInvBar	
	ld a,c
	cp b
	jr z,DoMenuDownT		
	inc b
	jr DoMenuBar		
DoMenuDownT:
	ld b,1		
DoMenuBar:
	call DoMenuInvBar
	jr DoMenuL	
DoMenuInvBar:
	push bc	
	ld h,b	
	ld l,112
	call _HtimesL
	ld de,$fc70 
	add hl,de
	call DoMenuInv	
	pop bc	
	ret		
DoMenuInv:
	ld b,7*16
DoMenuIL:
	ld a,(hl)
	cpl					
	ld (hl),a		
	inc hl	
	djnz DoMenuIL	
	ret	
;-------------------
TopBlack:
	call _clrLCD
	ld hl,$FC00
	ld (hl),$FF
	ld de,$FC01
	ld bc,111
	ldir
	set 3,(iy+5)
	ld de,$0001
	ld (_penCol),de
	ret
WriteReset:
	call _vputs
	res 3,(iy+5)
	ret
;--------------------
BottomBlack:
	ld b,112
	ld hl,$FF90
DrawBottom:
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	djnz DrawBottom
	ret
;--------------------
Exit:
	call _clrLCD
	jp _jforcecmdnochar
WhichType:
	ld a,1
	cp b
	jp z,LinearX
	inc a
	cp b
	jp z,TrigPlanX
	inc a
	cp b
	jp z,BentX
	inc a
	cp b
	jp z,TrigPyrX
	jp nz,TetraX

LinearX:
    ld hl,Linear
	call UseRLE
Linear:
#include "Linear.asm"
;--------------------
UseRLE:
    ld de,$fc00	
    call DispRLE
    call _getkey
    jp ProgStart	
#include "rle.asm"
	ret
TrigPlanX:
	ld hl,TrigPlan
	call UseRLE
TrigPlan:
#include "TrigPlan.asm"
;--------------------
BentX:
	ld hl,Bent
	call UseRLE
Bent:
#include "Bent.asm"
;--------------------
TrigPyrX:
	ld hl,TrigPyr
	call UseRLE
TrigPyr:
#include "TrigPyr.asm"
;--------------------
TetraX:
	ld hl,Tetra
	call UseRLE
Tetra:
#include "Tetra.asm"
;--------------------
.end
